import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Map.Entry;

public class Gradebook { // Make final to prevent phishing classes
	private HashMap<Integer, Student> Students;
	private LinkedList<String> Studentlist;
	
	public Gradebook() {
		Students = new HashMap<Integer, Student>();
		Studentlist = new LinkedList<String>();
	}
	
	public void addStudent(Student student) {
		Students.put(student.getID().hashCode(), student.copy());
		Studentlist.add(student.getID());
	}

	public void addGrade(String id, Grade grade) {
		Student student = Students.get(id.hashCode());
		grade = checkGrade(grade);
		student.addGrade(grade);
		//Students.put(student.getID().hashCode(), student);
	}
	
	public void print() {
//		Iterator<String> iter = Studentlist.iterator();
		Iterator<Entry<Integer, Student>> iter = Students.entrySet().iterator();
		while(iter.hasNext())
			System.out.print(iter.next().getValue());
//			System.out.print(Students.get(iter.next().hashCode()));

//		Iterator<Entry<Integer, Student>> iter = Students.entrySet().iterator();
//		while(iter.hasNext())
//			System.out.print(iter.next().getValue());
		System.out.println();
	}
	
	public Grade checkGrade(Grade grade) {
		grade = new Grade(grade.assignment, Math.min(grade.score, 100));
		//if(grade.score > 100)
		//	grade.score = 100;
		return grade;
	}
	
}
